/** ------------------------------------------------------------
 * A U T O   G E N E R A T E D  (First time only!)
 * Generator: Rocs ogen (build Feb 24 2013 22:27:36)
 * Module: RocDigs
 * XML: $Source: /cvsroot/rojav/rocdigs/rocdigs.xml,v $
 * XML: $Revision: 1.14 $
 * Object: rocpi
 * Date: Mon Mar 18 13:34:18 2013
 * ------------------------------------------------------------
 * $Source$
 * $Author$
 * $Date$
 * $Revision$
 * $Name$
 */

#include "rocdigs/impl/rocpi_impl.h"

#include "rocs/public/mem.h"
#include "rocutils/public/addr.h"
#include "rocrail/wrapper/public/rocpi.h"

#include "rocs/public/system.h"
#include "rocs/public/trace.h"

#include "rocrail/wrapper/public/DigInt.h"
#include "rocrail/wrapper/public/SysCmd.h"
#include "rocrail/wrapper/public/FunCmd.h"
#include "rocrail/wrapper/public/Loc.h"
#include "rocrail/wrapper/public/Switch.h"
#include "rocrail/wrapper/public/Output.h"
#include "rocrail/wrapper/public/Signal.h"
#include "rocrail/wrapper/public/Response.h"
#include "rocrail/wrapper/public/Program.h"
#include "rocrail/wrapper/public/State.h"

#include "rocdigs/impl/rocpi/commands.h"
#include "rocdigs/impl/rocpi/rpic.h"


static int instCnt = 0;

//Same structure as DDX
void rocrail_rocpiStateChanged(obj inst);

typedef struct _tDelayedAccCmd {
   char acc_p;
   int  acc_addr;
   int  acc_port;
   int  acc_gate;
   int  action;
   int  delay;
   int  busnr;
   int  devicegroup;
} tDelayedAccCmd;

/** ----- OBase ----- */
static void __del(void* inst) {
  if (inst != NULL) {
    iOrocpiData data = Data(inst);
    /* Cleanup data->xxx members...*/

    
	freeMem(data);
    freeMem(inst);
    instCnt--;
  }
  return;
}

static const char* __name(void) {
  return name;
}

static unsigned char* __serialize(void* inst, long* size) {
  return NULL;
}

static void __deserialize(void* inst, unsigned char* bytestream) {
  return;
}

static char* __toString(void* inst) {
  return NULL;
}

static int __count(void) {
  return instCnt;
}

static struct OBase* __clone(void* inst) {
  return NULL;
}

static Boolean __equals(void* inst1, void* inst2) {
  return False;
}

static void* __properties(void* inst) {
  iOrocpiData data = Data(inst);
  return NULL;
}

static const char* __id(void* inst) {
  return NULL;
}

static void* __event(void* inst, const void* evt) {
  return NULL;
}

/** ----- Orocpi ----- */

void thr_delayedAccCmd(void *threadinst) {

  iOThread th = (iOThread) threadinst;
  obj v = ThreadOp.getParm(th);               //Copied from void thr_refresh_cycle(void *threadinst) in locppol.c
  iOrocpiData data = Data((iOrocpi) v);
  tDelayedAccCmd *cmd = (tDelayedAccCmd *) v;

  unsigned char buffer[MAXBYTES];
  unsigned char response;

  TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
      "Delayed AccCmd received. delay: %d, protocol: %c\n", cmd->delay,
      cmd->acc_p);

  ThreadOp.sleep(cmd->delay);

    switch (cmd->acc_p) {
    case 'M':
        response=sendrpiccommand(buffer, ACCMMCMD, ACCMM, 3, data->socket);
        break;
    //function not yet implemented
     case 'N':
      buffer[2] = (char) cmd->acc_addr;
    if (cmd->acc_addr < 256) {
      buffer[1] = 0;
    } else {
      buffer[1] = cmd->acc_addr / 256; //8 shifts to right to ger the high byte... otherwise buffer[1]=1...NMRA address go from 0 to 511... so the only posibility is bufffer[1]=1
    }
    buffer[3] = cmd->acc_gate + cmd->acc_port * 2 + cmd->action * 8; //shifting the information to its rigth place   CDDD C=action DD=port D=gate
    response=sendrpiccommand(buffer, ACCNMRACMD, ACCNMRA, 4, data->socket);
    break;
  }

  TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999, "Delayed AccCmd sent.\n");
  freeMem(cmd);
  return;
}

static iONode __translate(obj inst, const iONode node) {
  iOrocpiData data = Data((iOrocpi) inst);
  iONode rsp = NULL; //rsp structure... so far not used.. it seems to be used in programming and sensors

  unsigned char buffer[MAXBYTES];
  unsigned char response;

  TraceOp.trc(name, TRCLEVEL_INFO, __LINE__, 9999, "translating: %s",
      NodeOp.getName(node));

  /* System command. */
  if (StrOp.equals(NodeOp.getName(node), wSysCmd.name())) {
    const char* cmdstr = wSysCmd.getcmd(node);
    TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999, "translating: cmd=%s",
        cmdstr);

    srand(time(NULL));
    buffer[1] = rand() % 255;

    if (StrOp.equals(cmdstr, wSysCmd.stop)
        || StrOp.equals(cmdstr, wSysCmd.ebreak)) {
      response=sendrpiccommand(buffer, SYSTEMCMD, CYCLEOFF, 2, data->socket);
      data->powerflag = 0;
      rocrail_rocpiStateChanged(inst);
    } else if (StrOp.equals(cmdstr, wSysCmd.go)) {
       response=sendrpiccommand(buffer, SYSTEMCMD, CYCLEON, 2, data->socket);
	    data->powerflag = 1;
      rocrail_rocpiStateChanged(inst);
    }

  }

  /* Signal command. */
  else if (StrOp.equals(NodeOp.getName(node), wSignal.name())) {
    TraceOp.trc(name, TRCLEVEL_WARNING, __LINE__, 9999,
        "Signal commands are no longer supported at this level.");
  }

  /* Output command. */
  else if (StrOp.equals(NodeOp.getName(node), wOutput.name())) {
    int action = StrOp.equals(wOutput.getcmd(node), wOutput.on) ? 0x01 : 0x00;
    int addr = wOutput.getaddr(node);
    int port = wOutput.getport(node);
    int gate = wOutput.getgate(node);

    if (port == 0) {
      int l_addr = addr;
      AddrOp.fromFADA(addr, &addr, &port, &gate);
      TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
          "sw FADA addr=%d converted to addr=%d port=%d gate=%d", l_addr, addr,
          port, gate);
    }

    else if (addr == 0 && port > 0) {
      int l_port = port;
      AddrOp.fromPADA(port, &addr, &port);
      TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
          "sw PADA port=%d converted to addr=%d port=%d gate=%d", l_port, addr,
          port, gate);
    }

    if (addr < 0 || port < 1 || port > 4 || gate < 0 || gate > 1) {

      TraceOp.trc("OUTPUT", TRCLEVEL_WARNING, __LINE__, 9999,
          "accessory out of range: %d %d %d %s", addr, port, gate,
          (action ? "ON" : "OFF"));
    } else {

      TraceOp.trc(name, TRCLEVEL_INFO, __LINE__, 9999,
          "co addr=%d port=%d gate=%d action=%d", addr, port, gate, action);

      if (StrOp.equals(wSignal.prot_M, wOutput.getprot(node))) {
          response=sendrpiccommand(buffer, ACCMMCMD, ACCMM, 3, data->socket);    ///Function not yet implemented in rocpi
      } else if (StrOp.equals(wSignal.prot_N, wOutput.getprot(node))) {
        buffer[2] = (char) addr;
        if (addr < 256) {
          buffer[1] = 0;
        } else {
          buffer[1] = addr / 256; //8 shifts to right to get the high byte... otherwise buffer[1]=1...NMRA address go from 0 to 511... so the only possibility is buffer[1]=1
        }
        port--;
        buffer[3] = gate + port * 2 + action * 8; //shifting the information to its right place   CDDD C=action DD=port D=gate
        response=sendrpiccommand(buffer, ACCNMRACMD, ACCNMRA, 4, data->socket);
      }
    }
  }

  /* Switch command. */
  else if (StrOp.equals(NodeOp.getName(node), wSwitch.name())) {
    int error = 0;
    tDelayedAccCmd *delayedCmd = NULL;
    int delay = 0;
    int port = wSwitch.getport1(node);
    int addr = wSwitch.getaddr1(node);
    int action = 1;
    int gate = 0;

    if (port == 0) {
      int l_addr = addr;
      AddrOp.fromFADA(addr, &addr, &port, &gate);
      TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
          "sw FADA addr=%d converted to addr=%d port=%d gate=%d", l_addr, addr,
          port, gate);
    } else if (addr == 0 && port > 0) {
      int l_port = port;
      AddrOp.fromPADA(port, &addr, &port);
      TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
          "sw PADA port=%d converted to addr=%d port=%d gate=%d", l_port, addr,
          port, gate);
    } else {
      int l_addr = AddrOp.toFADA(addr, port, gate);
      TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
          "sw FADA would be addr=%d or addr=%d", l_addr, l_addr + 1);
    }

    gate = StrOp.equals(wSwitch.getcmd(node), wSwitch.turnout) ? 0x00 : 0x01;

    /* to get two decouples at one address: */
    if (StrOp.equals(wSwitch.gettype(node), wSwitch.decoupler))
      gate = wSwitch.getgate1(node);

    if (wSwitch.issinglegate(node)) {
      gate = wSwitch.getgate1(node);
      delay = 0;
      if (StrOp.equals(wSwitch.getcmd(node), wSwitch.straight))
        action = 0;
    }

    TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
        "sw addr=%d port=%d gate=%d", addr, port, gate);

    if (wSwitch.isactdelay(node))
      delay = wSwitch.getdelay(node);

    if (StrOp.equals(wSignal.prot_M, wSwitch.getprot(node))) {
      response=sendrpiccommand(buffer, ACCMMCMD, ACCMM, 3, data->socket);
      //function not yet implemented
    } else if (StrOp.equals(wSignal.prot_N, wSwitch.getprot(node))) {
      buffer[2] = (char) addr;
      if (addr < 256) {
        buffer[1] = 0;
      } else {
        buffer[1] = addr / 256; //8 shifts to right to ger the high byte... otherwise buffer[1]=1...NMRA address go from 0 to 511... so the only posibility is bufffer[1]=1
      }
      port--;
      buffer[3] = gate + port * 2 + action * 8; //shifting the information to its rigth place   CDDD C=action DD=port D=gate
      response=sendrpiccommand(buffer, ACCNMRACMD, ACCNMRA, 4, data->socket);
    }

    if (delay > 0) {
      delayedCmd = (tDelayedAccCmd*) allocMem(sizeof(tDelayedAccCmd));
      if (delayedCmd) {
        delayedCmd->acc_p = wSwitch.getprot(node)[0];
        delayedCmd->acc_addr = addr;
        delayedCmd->acc_port = port;
        delayedCmd->acc_gate = gate;
        delayedCmd->action = 0;
        delayedCmd->delay = delay;
        delayedCmd->busnr = -1;
        delayedCmd->devicegroup = -1;
        data->swReset = ThreadOp.inst(NULL, &thr_delayedAccCmd, delayedCmd);
        ThreadOp.start(data->swReset);
      }
    }
  }

  /* Loc command. */
  else if (StrOp.equals(NodeOp.getName(node), wLoc.name())
      || ((StrOp.equals(NodeOp.getName(node), wFunCmd.name()))
          && (StrOp.equals(wLoc.getprot(node), wLoc.prot_M)))) {
    //That's right...Func in MM requires also the information of speed... so it has to be treated here...actually MM commands are sent depending on the function changed.. and this is only know by the digital station


    int addr = wLoc.getaddr(node);
    int dir = wLoc.isdir(node);
    int spcnt = wLoc.getspcnt(node);
    int speed = 0;

    if (spcnt > 127)
      spcnt = 127;

    if (StrOp.equals(wLoc.getV_mode(node), wLoc.V_mode_percent))
      speed = (wLoc.getV(node) * spcnt) / 100;
    else if (wLoc.getV_max(node) > 0)
      speed = (wLoc.getV(node) * spcnt) / wLoc.getV_max(node);

    if (StrOp.equals(wLoc.getprot(node), wLoc.prot_M)) {

      int protver = wLoc.getprotver(node);
      Boolean fn0 = wLoc.isfn(node);
      Boolean fn1 = wFunCmd.isf1(node);
      Boolean fn2 = wFunCmd.isf2(node);
      Boolean fn3 = wFunCmd.isf3(node);
      Boolean fn4 = wFunCmd.isf4(node);
      TraceOp.trc(name, TRCLEVEL_MONITOR, __LINE__, 9999,
          "lc=%d prot=MM%d spd=%d dir=%s lights=%s f1=%s f2=%s f3=%s f4=%s",
          addr, protver, speed, dir ? "forward" : "reverse", fn0 ? "on" : "off",
          fn1 ? "on" : "off", fn2 ? "on" : "off", fn3 ? "on" : "off",
          fn4 ? "on" : "off");

      buffer[1] = addr;
      buffer[2] = speed + dir * 128;                            //dspeed byte is speed+direction in MSB...
      buffer[3] = fn0 + fn1 * 2 + fn2 * 4 + fn3 * 8 + fn4 * 16; //function byte  F4F3F2F1F0

      switch (protver) {
      case 1:
        response=sendrpiccommand(buffer, LOCMMCMD, LOCOMM1, 4, data->socket);
        break;
      case 2:
        response=sendrpiccommand(buffer, LOCMMCMD, LOCOMM2, 4, data->socket);
        break;
      case 3:
        response=sendrpiccommand(buffer, LOCMMCMD, LOCOMM3, 4, data->socket);       //not yet implemented in rpic
        break;
      case 4:
        response=sendrpiccommand(buffer, LOCMMCMD, LOCOMM4, 4, data->socket);       //not yet implemented in rpic
        break;
      case 5:
        response=sendrpiccommand(buffer, LOCMMCMD, LOCOMM5, 4, data->socket);       //not yet implemented in rpic
        break;
      case 6:
        buffer[4] = buffer[3];
        buffer[3] = buffer[2];
        buffer[2] = (char) addr;
        if (addr < 256) {
          buffer[1] = 0;
        } else {
          buffer[1] = addr / 256; //8 shifts to right to ger the high byte... otherwise buffer[1]=1...NMRA address go from 0 to 511... so the only posibility is bufffer[1]=1
        }
        Boolean fn5 = wFunCmd.isf5(node);
        Boolean fn6 = wFunCmd.isf6(node);
        Boolean fn7 = wFunCmd.isf7(node);
        buffer[4] = buffer[4] + fn5 * 32 + fn6 * 64 + fn7 * 128;
        Boolean fn8 = wFunCmd.isf8(node);
        Boolean fn9 = wFunCmd.isf9(node);
        Boolean fn10 = wFunCmd.isf10(node);
        Boolean fn11 = wFunCmd.isf11(node);
        Boolean fn12 = wFunCmd.isf12(node);
        Boolean fn13 = wFunCmd.isf13(node);
        Boolean fn14 = wFunCmd.isf14(node);
        Boolean fn15 = wFunCmd.isf15(node);
   //     buffer[5] = fn8 + fn9 * 2 + fn10 * 4 + fn11 * 8 + fn12 * 16 + fn13 * 32 + fn14 * 64 + fn15 * 128;     //alpha version testing only support 8 functions

        response=sendrpiccommand(buffer, LOCMMXCMD, LOCOMMX, 5, data->socket);       //not yet implemented in rpic
        //response=sendrpiccommand(buffer, LOCMMXCMD, LOCOMMX, 6, data->socket);       //not yet implemented in rpic
        break;
      }

    } else if (StrOp.equals(wLoc.getprot(node), wLoc.prot_N)) {
      TraceOp.trc(name, TRCLEVEL_MONITOR, __LINE__, 9999,
          "lc=%d prot=DCCS/%d spd=%d dir=%s", addr, spcnt, speed,
          dir ? "forward" : "reverse");

      buffer[1] = addr;
      buffer[2] = speed + dir * 128;

      switch (spcnt) {
      case 14:
        response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCN14, 3, data->socket);
        break;
      case 28:
        response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCN28, 3, data->socket);
        break;
      case 127:
        response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCN128, 3, data->socket);
        break;
      default:
        TraceOp.trc(name, TRCLEVEL_WARNING, __LINE__, 9999,
            "error sending DCC packet. Decoder steps must be selected from 14,28 or128");
      }
    } else if (StrOp.equals(wLoc.getprot(node), wLoc.prot_L)) {
      // int rc = 0;
      TraceOp.trc(name, TRCLEVEL_MONITOR, __LINE__, 9999,
          "lc=%d prot=DCCL/%d spd=%d dir=%s", addr, spcnt, speed,
          dir ? "forward" : "reverse");

      buffer[2] = (char) addr;
      if (addr < 256) {
        buffer[1] = 0;
      } else {
        buffer[1] = addr / 256; //8 shifts to right to ger the high byte... otherwise buffer[1]=1...NMRA address go from 0 to 511... so the only posibility is bufffer[1]=1
      }

      buffer[3] = speed + dir * 128;

      switch (spcnt) {
      case 14:
        response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCL14, 4, data->socket);
        break;
      case 28:
        response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCL28, 4, data->socket);
        break;
      case 127:
        response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCL128, 4, data->socket);
        break;
      default:
        TraceOp.trc(name, TRCLEVEL_WARNING, __LINE__, 9999,
            "error sending DCC packet. Decoder steps must be selected from 14,28 or128");
      }
    } else {
      /* default */
      TraceOp.trc(name, TRCLEVEL_WARNING, __LINE__, 9999,
          "unsupported protocol [%s]", wLoc.getprot(node));
    }

  }

  /* Function command. */
  else if (StrOp.equals(NodeOp.getName(node), wFunCmd.name())) {
    int addr = wFunCmd.getaddr(node);
    int fgroup = wFunCmd.getgroup(node);
    int f[29];
    unsigned char fbyte;

    f[0] = wFunCmd.isf0(node);
    f[1] = wFunCmd.isf1(node);
    f[2] = wFunCmd.isf2(node);
    f[3] = wFunCmd.isf3(node);
    f[4] = wFunCmd.isf4(node);
    f[5] = wFunCmd.isf5(node);
    f[6] = wFunCmd.isf6(node);
    f[7] = wFunCmd.isf7(node);
    f[8] = wFunCmd.isf8(node);
    f[9] = wFunCmd.isf9(node);
    f[10] = wFunCmd.isf10(node);
    f[11] = wFunCmd.isf11(node);
    f[12] = wFunCmd.isf12(node);
    f[13] = wFunCmd.isf13(node);
    f[14] = wFunCmd.isf14(node);
    f[15] = wFunCmd.isf15(node);
    f[16] = wFunCmd.isf16(node);
    f[17] = wFunCmd.isf17(node);
    f[18] = wFunCmd.isf18(node);
    f[19] = wFunCmd.isf19(node);
    f[20] = wFunCmd.isf20(node);
    f[21] = wFunCmd.isf21(node);
    f[22] = wFunCmd.isf22(node);
    f[23] = wFunCmd.isf23(node);
    f[24] = wFunCmd.isf24(node);
    f[25] = wFunCmd.isf25(node);
    f[26] = wFunCmd.isf26(node);
    f[27] = wFunCmd.isf27(node);
    f[28] = wFunCmd.isf28(node);

    TraceOp.trc(name, TRCLEVEL_MONITOR, __LINE__, 9999,
        "lc=%d lights=%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
        addr, f[0] ? "on" : "off", f[1] ? "01" : "--", f[2] ? "02" : "--",
        f[3] ? "03" : "--", f[4] ? "04" : "--", f[5] ? "05" : "--",
        f[6] ? "06" : "--", f[7] ? "07" : "--", f[8] ? "08" : "--",
        f[9] ? "09" : "--", f[10] ? "10" : "--", f[11] ? "11" : "--",
        f[12] ? "12" : "--", f[13] ? "13" : "--", f[14] ? "14" : "--",
        f[15] ? "15" : "--", f[16] ? "16" : "--", f[17] ? "17" : "--",
        f[18] ? "18" : "--", f[19] ? "19" : "--", f[20] ? "20" : "--",
        f[21] ? "21" : "--", f[22] ? "22" : "--", f[23] ? "23" : "--",
        f[24] ? "24" : "--", f[25] ? "25" : "--", f[26] ? "26" : "--",
        f[27] ? "27" : "--", f[28] ? "28" : "--");


    fgroup--; /* function group from Rocview starts with 1 */ //from ddx

    switch (fgroup) {

    case 0:
      fbyte = f[0] + f[1] * 2 + f[2] * 4 + f[3] * 8 + f[4] * 16; //Note I send the fbyte as naturally ordered.. not as requested by dcc... central station will take care
      break;
    case 1:
      fbyte = f[5] + f[6] * 2 + f[7] * 4 + f[8] * 8;
      break;
    case 2:
      fbyte = f[9] + f[10] * 2 + f[11] * 4 + f[12] * 8;
      break;
    case 3:
    case 4:
      fbyte = f[13] + f[14] * 2 + f[15] * 4 + f[16] * 8 + f[17] * 16
          + f[18] * 32 + f[19] * 64 + f[20] * 128;
      break;
    case 5:
    case 6:
      fbyte = f[21] + f[22] * 2 + f[23] * 4 + f[24] * 8 + f[25] * 16
          + f[26] * 32 + f[27] * 64 + f[28] * 128;
      break;
    default:
            fgroup=0;
            fbyte = f[0] + f[1] * 2 + f[2] * 4 + f[3] * 8 + f[4] * 16; //Note I send the fbyte as naturally ordered.. not as requested by dcc... central station will take care
    }


    if (StrOp.equals(wLoc.getprot(node), wLoc.prot_N)) {
      buffer[1] = addr;
      buffer[2] = fbyte;
      buffer[3] = fgroup;
      response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCNfx, 4, data->socket);
    } else if (StrOp.equals(wLoc.getprot(node), wLoc.prot_L)) {
      buffer[2] = (char) addr;
      if (addr < 256) {
        buffer[1] = 0;
      } else {
        buffer[1] = addr / 256; //8 shifts to right to ger the high byte... otherwise buffer[1]=1...NMRA address go from 0 to 511... so the only posibility is bufffer[1]=1
      }
      buffer[3] = fbyte;
      buffer[4] = fgroup;
      response=sendrpiccommand(buffer, LOCNMRACMD, LOCODCCLfx, 5, data->socket);
    } else {
      /* default */
      TraceOp.trc(name, TRCLEVEL_WARNING, __LINE__, 9999,
          "unsupported protocol [%s]", wLoc.getprot(node));
    }

  }

  /* Program command. */
   else if( StrOp.equals( NodeOp.getName( node ), wProgram.name() ) ) {
   Boolean pom = wProgram.ispom( node );
   rsp = NodeOp.inst( wProgram.name(), NULL, ELEMENT_NODE );
   if( data->iid != NULL )
   wProgram.setiid( rsp, data->iid );
   wProgram.setcmd( rsp, wProgram.datarsp );
   wProgram.setcv( rsp, wProgram.getcv( node ) );

   int cv = wProgram.getcv( node )-1;
   int val = wProgram.getvalue( node );
   // int ack = 0;   SO FAR NO CONTROL FOR ACK

   buffer[2] = (char) cv;
   buffer[1] =  cv/256;       //8 shifts to the right
   buffer[3]=val;

   if(  wProgram.getcmd( node ) == wProgram.ptstat ) {

   }
   else if(  wProgram.getcmd( node ) == wProgram.pton ) {
     srand(time(NULL));
     buffer[1] = rand() % 255;
     response=sendrpiccommand(buffer, SYSTEMCMD, PTON, 2, data->socket);
     data->ptflag = 1;
     rocrail_rocpiStateChanged(inst);           //No control error yet
                                                //in rocpi main track and pt are independant...it could be with voltage (the cycle will be affected because whiles PT, any command will go to the pt, not to the main track
   }
   else if( wProgram.getcmd( node ) == wProgram.ptoff ) {
     srand(time(NULL));
     buffer[1] = rand() % 255;
     response=sendrpiccommand(buffer, SYSTEMCMD, PTOFF, 2, data->socket);
     data->ptflag = 0;
   rocrail_rocpiStateChanged(inst);
   }
 //  else if( wProgram.getcmd( node ) == wProgram.get && isPT(inst) ) {         //getting only from PT..TBC
   else if( wProgram.getcmd( node ) == wProgram.get) {
   response=sendrpiccommand(buffer, PROGCMD, NMRA_SERVICE_MODE_DIRECT_verify, 4, data->socket);    //so far not implemented in rocpi
   //wProgram.setvalue( rsp, value );

   }
   //else if( wProgram.getcmd( node ) == wProgram.set && (pom?True:isPT(inst)) ) {
   else if( wProgram.getcmd( node ) == wProgram.set) {                      //so far no difference in POM or not

   response=sendrpiccommand(buffer, PROGCMD, NMRA_SERVICE_MODE_DIRECT_write, 4, data->socket);    //so far not implemented in rocpi
   //ack = protocol_nmra_sm_write_cvbyte(inst, cv-1, val, pom);       //no control of error so far

   //wProgram.setvalue( rsp, val );
   //if( ack != 1 && !pom )
   //wProgram.setvalue( rsp, -1 );
   }

   }


  return rsp;
}

/**  */
static iONode _cmd(obj inst, const iONode cmd) {

  iOrocpiData data = Data((iOrocpi) inst);
  iONode rsp = __translate(inst, cmd);

  /* Cleanup Node1 */
  NodeOp.base.del(cmd);

  return rsp;
}

/**  */
static byte* _cmdRaw(obj inst, const byte* cmd) {
  return 0;
}

/**  */
static void _halt(obj inst, Boolean poweroff) {       //would not be better if halt is the halt from the throttle to send the emergency break?
   iOrocpiData data = Data((iOrocpi)inst);

   unsigned char buffer[MAXBYTES];
   unsigned char response;

   srand(time(NULL));
   buffer[1] = rand() % 255;
   response=sendrpiccommand(buffer, SYSTEMCMD, CYCLEOFF, 2, data->socket);

   TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "Send halt-" );
   data->powerflag = 0;
   rocrail_rocpiStateChanged(inst);
   
   if ( SocketOp.isConnected( data->socket ))
    SocketOp.disConnect( data->socket );
   
   return;
}

/**  */
static Boolean _setListener(obj inst, obj listenerObj,                      //TB further studied
    const digint_listener listenerFun) {
  iOrocpiData data = Data(inst);
   data->listenerObj = listenerObj;
   data->listenerFun = listenerFun;
   return True;
}

/**  */
static Boolean _setRawListener(obj inst, obj listenerObj,                 //TB further studied
    const digint_rawlistener listenerRawFun) {
 // return 0;
  return True;
}

/** external shortcut event */
static void _shortcut(obj inst) {
  iOrocpiData data = Data( inst );
  TraceOp.trc( name, TRCLEVEL_MONITOR, __LINE__, 9999, "external shortcut event; power off." );
   unsigned char buffer[MAXBYTES];
   unsigned char response;

   srand(time(NULL));
   buffer[1] = rand() % 255;
   response=sendrpiccommand(buffer, SYSTEMCMD, CYCLEOFF, 2, data->socket);

   TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "Send shortcut-" );
   
   data->powerflag = 0;
   rocrail_rocpiStateChanged(inst);

}

/** bit0=power, bit1=programming, bit2=connection */
static int _state(obj inst) {
  iOrocpiData data = Data((iOrocpi)inst);
  int state = 0;
  state |= data->powerflag << 0;
  state |= data->ptflag << 1;
  state |= data->communicationflag << 2;
  return state;
}


void rocrail_rocpiStateChanged( obj inst ) {
    iOrocpiData data = Data(inst);
    iONode node = NodeOp.inst( wState.name(), NULL, ELEMENT_NODE );
    wState.setiid( node, wDigInt.getiid( data->ini ) );
    wState.setpower( node, data->powerflag?True:False );
    wState.setprogramming( node, data->ptflag?True:False );
    wState.settrackbus( node, data->communicationflag?True:False );
    wState.setaccessorybus( node, data->communicationflag?True:False );
    if( data->listenerFun != NULL ) {
      data->listenerFun( data->listenerObj, node, TRCLEVEL_INFO );
    }
}

/**  */
static Boolean _supportPT(obj inst) {
  iOrocpiData data = Data((iOrocpi)inst);
  return True;
}

/** vmajor*1000 + vminor*100 + patch */
static int vmajor = 2;
static int vminor = 0;
static int patch  = 0;
static int _version(obj inst) {
  iOrocpiData data = Data(inst);
  return vmajor*10000 + vminor*100 + patch;
}

/**  */
static struct Orocpi* _inst(const iONode ini, const iOTrace trc) {
  iOrocpi __rocpi = allocMem( sizeof( struct Orocpi ) );
  iOrocpiData data = allocMem( sizeof( struct OrocpiData ) );
  iONode rocpi_ini = NULL;
  unsigned char error=OK;
  MemOp.basecpy(__rocpi, &rocpiOp, 0, sizeof(struct Orocpi), data);

   TraceOp.set(trc);
  /* Initialize data->xxx members... */

   //rocrailready(False);                     //not anymore... impossible to send any message until connectionis created


   /* make a clone of the ini node: it could be replaced by rocrailDialog in the rocgui... */
     data->ini = (iONode)NodeOp.base.clone( ini );
     data->iid = StrOp.dup(wDigInt.getiid( ini ));

     rocpi_ini = wDigInt.getrocpi( data->ini );
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "----------------------------------------" );
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "ROCPI ROCrail for raspberry-PI");
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "----------------------------------------" );
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "rocpi %d.%d.%d", vmajor, vminor, patch );
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "----------------------------------------" );
     data->host      = wDigInt.gethost( rocpi_ini );       /* host address */
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "rpicd Host =%s", data->host );
     data->port      = wDigInt.getport( rocpi_ini );       /* port, usually 8888 */
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "rocpi Port =%i", data->port );
//     data->timeoutR= wrocpi.gettimeoutR( rocpi_ini );
//     data->timeoutW= wrocpi.gettimeoutW( rocpi_ini ); //so far no treatment of delays anymore
//     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "rocpi Timeout Reading %d ms", data->timeoutR );
//     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "rocpi Timeout Writing %d ms", data->timeoutW );
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "----------------------------------------");
     TraceOp.trc( name, TRCLEVEL_INFO, __LINE__, 9999, "Starting Rocpi..." );
     SystemOp.inst();
//     data->serial = NULL;

     data->communicationflag = 0;
	   data->powerflag = 0;
//     rocrail_rocpiStateChanged(__rocpi);   nothing to be sent.. until the soket is open

	   /* Create a socket object: */

	  if ( data->socket == NULL )
	    data->socket = SocketOp.inst( data->host, data->port, False, False, False );

	    /* Disconnect if connected */

	  if ( SocketOp.isConnected( data->socket ))
	    SocketOp.disConnect( data->socket );

	  TraceOp.trc( name, TRCLEVEL_DEBUG, __LINE__, 9999, "Connecting to rpicd at %s:%d",
	               data->host, data->port );

	  if ( !SocketOp.connect( data->socket )) {
	    TraceOp.trc( name, TRCLEVEL_EXCEPTION, __LINE__, 9999, "ERROR connecting to rpicd at %s:%d",
	                 data->host, data->port );
	    error=ERROR2;
	  }

     TraceOp.trc( __FILE__, TRCLEVEL_INFO, __LINE__, 9999, "Connected to rpicd at %s:%d",
                   data->host, data->port );
     if (error==OK){
       data->communicationflag = 1;}
     rocrail_rocpiStateChanged(__rocpi);
     //rocrailready(True); //this should be handled directly by the rocpd


  instCnt++;
  return __rocpi;
}

/* Support for dynamic Loading */
 iIDigInt rocGetDigInt(const iONode ini, const iOTrace trc) {
   return (iIDigInt) _inst(ini, trc);
 }

/* ----- DO NOT REMOVE OR EDIT THIS INCLUDE LINE! -----*/
#include "rocdigs/impl/rocpi.fm"
/* ----- DO NOT REMOVE OR EDIT THIS INCLUDE LINE! -----*/
