/*
 * rpic.c
 *
 *  Created on: 06/04/2013
 *      Author: Manolo Serrano
 *      http://tren.enmicasa.net
 *
 *      This file makes used of the WiringPi library developed by Gordon Hendersons (https://projects.drogon.net/raspberry-pi/wiringpi/)
 *      The folder contains the README file and GPL provided by the original distribution, and three of the files needed: wiringPi.c, wiringPi.h and piHiPri.c
 *      The only modification in the source code of such files is a precompiler directive to avoid the compilation when rpic is being compiled for non-arm targets.
 */

#include "rocdigs/impl/rocpi_impl.h"
#include "rocdigs/impl/rocpi/rpic.h"


unsigned char sendrpiccommand(unsigned char buffer[], unsigned char command, unsigned char type,unsigned char commandlength, iOSocket rpicd){
  unsigned char i;

  buffer[0]=((command<<5)&0b11100000)|type;
    buffer[commandlength]=checksum(buffer, 0, commandlength - 1);

    SocketOp.write( rpicd, buffer, commandlength + 1 );
       //TraceOp.trc( name, TRCLEVEL_DEBUG, __LINE__, 9999, "Sendcommand" );

    for (i = 0; i < commandlength + 1; i++) {
      //TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999,
      TraceOp.trc(name, TRCLEVEL_INFO, __LINE__, 9999,
          "Command sent buffer %d:  %X", i, buffer[i]);
    }
   // i=0;                                                  So far no response received
    //SerialOp.read(serialcom, &i, 1);
    //TraceOp.trc(name, TRCLEVEL_DEBUG, __LINE__, 9999, "Response Received %X", i);
    //TraceOp.trc(name, TRCLEVEL_INFO, __LINE__, 9999, "Response Received %X", i);


    //error control over i should come here...if error: try to send it again... flush and inform the type of errot (error handler needed)
    //.. if no error...could be the response of a lecture of cv.. and it has to be returned in i.. otherwise i is not used by rocpi

    return i;
}

unsigned char checksum(unsigned char toverify[], unsigned char firstbyte, unsigned char lastbyte) {
    unsigned char i;
    unsigned char sum = toverify[firstbyte];

    for (i = firstbyte; i != lastbyte; i++) {
        sum = sum^toverify[i + 1];
    }
    return sum;
}

